'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbannotate.exe
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
#Include "Win32API.inc"   'Jose Roca Includes
#Include "cgdiplus.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "icons\gbannotate.ico"
#Resource Icon xopen "icons\open.ico"
#Resource Icon xsaveas "icons\save.ico"
#Resource Icon xxprint "icons\print.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xfont "icons\font.ico"
#Resource Icon xclear "icons\clear.ico"
#Resource Icon xcopy "icons\copy.ico"
#Resource Icon xpdf "icons\pdf.ico"
#Resource Icon xundo "icons\undo.ico"
#Resource Icon xpaste "icons\paste.ico"
#Resource Icon xdraw "icons\draw.ico"
#Resource Icon xtext "icons\text.ico"
#Resource Icon xstamp "icons\smiley.ico"
#Resource Icon xcut "icons\cut.ico"
#Resource Icon xplus "icons\plus.ico"
#Resource Icon xminus "icons\minus.ico"
#Resource Icon xsort "icons\sort.ico"

$Ver = "2.2"
$ClipboardBMP = "temp\gbannotate.bmp"
$ML = "|"
%MaxFields = 100
%Margin = 20

Type CustomColors
   c(15) As Long
End Type

Type FormFields
   fieldtype As Long           ' %TypeText, %TypeDraw, %TypeStamp
   used As Long
   s As StringZ * %Max_Path    'field text, stamp file name, or object name (arrow,rect,circle)
   rc As Rect
   fname As StringZ * 50
   fsize As Long
   fattr As Long
   fcolor As Long
   ssize As Long    'stamp size
   shorz As Long
   svert As Long
   dtype As Long    'DrawLine DrawArrow DrawBox DrawEllipse
   dcolor As Long   'draw color
   dwidth As Long   'draw line width
   dfilled As Long
   tbd1 As Long
   tbd2 As Long
   tbd3 As Long
   tbd4 As Long
   tbd5 As Long
End Type

Type ArrowType
   count As Long
   x1 As Single
   y1 As Single
   x2 As Single
   y2 As Single
   x3 As Single
   y3 As Single
   x4 As Single
   y4 As Single
   x5 As Single
   y5 As Single
   x6 As Single
   y6 As Single
   x7 As Single
   y7 As Single
End Type

Enum Equates Singular
   IDC_Graphic = 500
   IDC_Stamps
   IDC_Toolbar
   IDC_TextBox
   IDC_ComboBox
   IDC_StatusBar

   IDT_OpenImage
   IDT_Save
   IDT_PDF
   IDT_Clear
   IDT_Undo
   IDT_Text
   IDT_Stamp
   IDT_Draw
   IDT_Font
   IDT_Copy
   IDT_Plus
   IDT_Minus
   IDT_Paste
   IDT_Settings
   IDT_Help

   IDM_DrawLine
   IDM_DrawBox
   IDM_DrawEllipse
   IDM_DrawArrow

   IDM_Width1
   IDM_Width2
   IDM_Width4
   IDM_Width8

   IDM_Filled

   IDM_Stamp256
   IDM_Stamp192
   IDM_Stamp128
   IDM_Stamp96
   IDM_Stamp64
   IDM_Stamp48
   IDM_Stamp32
   IDM_Stamp24
   IDM_StampHorz
   IDM_StampVert

   IDM_KillGBA
   IDM_Sort
   IDM_Print

   IDM_Sep
   IDM_Return
   IDM_UnselectAll
   IDM_DrawColor
   IDM_FontColor
   IDM_RemoveCFF
   IDM_RemoveEmpty
   IDM_ShowCFFData
   IDM_SendToBack
   IDM_AutoSave
   IDM_AutoTAB
   IDM_AutoOpenPDF
   IDM_AutoUnDraw
   IDM_OpenPDF
   IDM_StampBG
   IDM_ShowCFFBoundary
   IDM_ShowBoundary
   IDM_ShowLibrary
   IDM_Test

   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete

   IDM_DrawWhite
   IDM_DrawBlack
   IDM_DrawRed
   IDM_DrawBlue
   IDM_FontWhite
   IDM_FontBlack
   IDM_FontRed
   IDM_FontBlue
   IDM_AllSameFont

   IDM_EditAtTop
   IDM_Home
   IDM_End
   IDM_Tab
   IDM_ShiftTAB
   IDM_Font8
   IDM_Font10
   IDM_Font12
   IDM_Font16
   IDM_Font24
   IDM_Font32
   IDM_Font54
   IDM_Font72

   TypeText = 1
   TypeStamp
   TypeDraw

   DrawLine = 1
   DrawArrow
   DrawBox
   DrawEllipse
End Enum

Global hDlg,hBMP,hToolbar,ghHook,hTextBox As Dword
Global hGraphic,hFont,hSettings,hStamp,hDraw,hContext,hContextTB,hFontT As Dword
Global imgW, imgH,TrueImageSize, CFF, CFS, CFD, FieldType, DrawType As Long
Global FontSize, FontAttr, FontColor, DrawColor,DrawWidth,AutoSave, AutoTAB, AutoOpenPDF As Long
Global CustomColorList As CustomColors, Symbols(), AllSymbols() As String
Global ImageFileName,FontName,Marker, SymbolCategory  As WStringZ * %Max_Path
Global FF() As FormFields, StampBG, StampSize, ShowBoundary, ShowCFFBoundary,SymbolSelect  As Long
Global FieldMoveInWork, FieldDrawInWork,OldTextBoxProc,Filled,StampHorz,StampVert As Long
Global ContextPT As Point, Dirty, EditAtTop, OldGraphicProc, AutoUnDraw, ShowLibrary As Long

Function PBMain() As Long
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, 0, "gbAnnotate    v" + $ver,300,600,500,500, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   DragAcceptFiles hDlg, %True
   CreateSubFolders
   CreateToolbar
   Control Add TextBox, hDlg, %IDC_TextBox, "", 100,100,20,20
   Control Handle hDlg, %IDC_TextBox To hTextBox
   OldTextBoxProc = SetWindowLong(hTextBox, %GWL_WndProc, CodePtr(NewTextBoxProc))  'subclass
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local x,y,iResult,i As Long, pt As Point
   Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr, rc As Rect, tempZ As WStringZ *%Max_Path
   Static ddx,ddy As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         ReDim FF(%MaxFields)
         settings_ini "get"
         CreateStamps
         UpdateStamps
         LoadComboBox
         SelectCFS %Red
         CreateGraphic
         If IsFile(FFName) Then LoadFFName
         Dialog Set Text hDlg,"gbAnnotate    v" + $ver + "     " + LCase$(ImageFileName)
         LoadImageFile
         LoadFormFile
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         Graphic Set Virtual imgW, imgH   'large virtual canvas
         Graphic Set Overlap %True
         Graphic Copy hBMP,0
         If CFF > -1 Then Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         DrawBoxAndText(0)
         UpdateStatusBar
         SetMenusAndToolbar
         ReplaceDrawButton
         ManageLibrary
      Case %WM_DROPFILES
         DragQueryFile Cb.WParam, 0, tempZ, SizeOf(tempZ)
         If IsFile(tempZ) And InStr(".gif.bmp.jpg.png",LCase$(Right$(tempZ,4))) Then
            If OkToProceed("drop") Then
               Dirty = 0
               ImageFileName = tempZ
               Dialog Set Text hDlg,"gbAnnotate    v" + $ver + "     " + LCase$(ImageFileName)
               LoadImageFile
               LoadFormFile
               Control Kill hDlg, %IDC_Graphic
               CreateGraphic
'               Graphic Attach hDlg, %IDC_Graphic, ReDraw
               Graphic Set Virtual imgW, imgH   'large virtual canvas
'               Graphic Clear
               Graphic Copy hBMP,0
               ResizeWindow
               DrawBoxAndText(0)
               UpdateStatusBar
            End If
         End If
         DragFinish Cb.WParam
      Case %WM_SysCommand
         If AutoSave Then
            SaveFormData
         Else
            If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
               If OkToProceed("end") = 0 Then Function = 1
            End If
         End If
      Case %WM_Destroy
         settings_ini "save"
         SetWindowLong hTextBox, %GWL_WndProc, OldTextBoxProc
         SetWindowLong hGraphic, %GWL_WNDPROC, OldGraphicProc
      Case %WM_Size
         ResizeWindow
      Case %WM_ContextMenu
         ContextPT.x = Lo(Integer,Cb.LParam) : ContextPT.y = Hi(Integer, Cb.LParam)            'WM_ContextMenu returns xy coordinates of mouse
         GetWindowRect(hGraphic,rc)
         If PtInRect(rc,ContextPT) Then
            TrackPopupMenu hContext, %TPM_LeftAlign, ContextPT.x, ContextPT.y, 0, hDlg, ByVal 0   'put context menu where mouse is
         End If

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_ComboBox
               Select Case Cb.CtlMsg
                  Case %CBN_SelChange
                     ComboBox Get Text hDlg, %IDC_ComboBox To SymbolCategory
                     ComboBox Get Select hDlg, %IDC_ComboBox To SymbolSelect
                     UpdateStamps
                     CFS = 0
                     SelectCFS %Red
               End Select
            Case %IDC_TextBox
               Select Case Cb.CtlMsg
                  Case %EN_Change
                     If CFF > -1 Then
                        If FF(CFF).fieldtype = %TypeText Then
                           Control Get Text hDlg, %IDC_TextBox To FF(CFF).s
                           SetCFFBoundary
                           UpdateStatusBar
                           DrawBoxAndText(0)
                        End If
                     End If
               End Select
            Case %IDC_Stamps
               Select Case Cb.CtlMsg
                  Case %STN_Clicked
                     HighlightNewCS
                     FieldType = %TypeStamp
                     SetMenusAndToolbar
               End Select
            Case %IDT_OpenImage : SelectImage
            Case %IDT_Save      : SaveFormData
            Case %IDT_PDF       : SaveAsJPG : ExportToPDF : If AutoOpenPDF Then ShellExecute(hDlg, "Open", Exe.Path$ + "pdf", $Nul, $Nul, %SW_Restore)
            Case %IDT_Copy      : CopyForm
            Case %IDT_Paste     : PasteFromClipboard
            Case %IDT_Clear     : ClearAll
            Case %IDT_Undo      : Undo

            Case %IDT_Plus      : IncreaseFieldSize
            Case %IDT_Minus     : DecreaseFieldSize

            Case %IDT_Text      : FieldType = %TypeText
            Case %IDT_Stamp     : FieldType = %TypeStamp
            Case %IDT_Draw      : FieldType = %TypeDraw

            Case %IDT_Font
               If SelectMainFont Then
                  Dirty = 1
                  FF(CFF).fname = FontName
                  FF(CFF).fsize = FontSize
                  FF(CFF).fattr = FontAttr
                  If FF(CFF).FieldType = %TypeText Then RefreshCFF
                  SetMenusAndToolbar
               End If

            Case %IDT_Settings  : DisplayReport
            Case %IDT_Help      : iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbannotate.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IdOk
'               Select Case GetFocus
'                  Case hTextBox
'                     If CFF > -1 Then
'                        If FieldType = %TypeText Then
'                           Control Get Text hDlg, %IDC_TextBox To FF(CFF).s
'                           SetCFFBoundary
'                           UpdateStatusbar
'                           DrawBoxAndText(0)
'                        End If
'                     End IF
'                  Case Else
'                     IF CFF > -1 Then Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
'               End Select
? "bingo"
               If AutoTAB Then GoToNextField
               UpdateStatusBar
               DrawBoxAndText(0)

            Case %IDM_UnselectAll   : CFF = -1 : DrawBoxAndText(0)
            Case %IDM_ShowCFFData   : ShowCFFData
            Case %IDM_RemoveCFF     : RemoveCFF
            Case %IDM_RemoveEmpty   : RemoveEmptyFields
            Case %IDM_SendToBack    : SendToBack

            Case %IDM_Filled   : FieldType = %TypeDraw : Filled   Xor= 1 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dfilled = Filled   : Dirty = 1 : DrawBoxAndText(0)
                  End If
               End If

            Case %IDM_Width1   : FieldType = %TypeDraw : DrawWidth = 1 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dwidth = DrawWidth : Dirty = 1 : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Width2   : FieldType = %TypeDraw : DrawWidth = 2 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dwidth = DrawWidth : Dirty = 1 : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Width4   : FieldType = %TypeDraw : DrawWidth = 4 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dwidth = DrawWidth : Dirty = 1 : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Width8   : FieldType = %TypeDraw : DrawWidth = 8 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dwidth = DrawWidth : Dirty = 1 : DrawBoxAndText(0)
                  End If
               End If
'

            Case %IDM_Font8    : FontSize = 8  : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font10   : FontSize = 10 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font12   : FontSize = 12 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font16   : FontSize = 16 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font24   : FontSize = 24 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font32   : FontSize = 32 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font54   : FontSize = 54 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If
            Case %IDM_Font72   : FontSize = 72 : SetMenusAndtoolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fsize = FontSize : RefreshCFF
                  End If
               End If

            Case %IDM_Sort      : SortFields
            Case %IDM_Print     : PrintFileName

            Case %IDM_FontWhite : FontColor = %White
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fColor = FontColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_FontBlack : FontColor = %Black
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fColor = FontColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_FontRed   : FontColor = %Red
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fColor = FontColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_FontBlue  : FontColor = %Blue
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).fColor = FontColor : DrawBoxAndText(0)
                  End If
               End If

            Case %IDM_AllSameFont : AllSameFont

            Case %IDM_FontColor
               iResult = FontColor
               FontColor = SelectColor(FontColor)
               If iResult <> FontColor And CFF > -1 Then
                  FF(CFF).fColor = FontColor
                  DrawBoxAndText(0)
               End If

            Case %IDM_DrawWhite : FieldType = %TypeDraw : SetMenusAndToolbar : DrawColor = %White
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dColor = DrawColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_DrawBlack : FieldType = %TypeDraw : SetMenusAndToolbar : DrawColor = %Black
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dColor = DrawColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_DrawRed   : FieldType = %TypeDraw : SetMenusAndToolbar : DrawColor = %Red
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dColor = DrawColor : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_DrawBlue  : FieldType = %TypeDraw : SetMenusAndToolbar : DrawColor = %Blue
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeDraw Then
                     FF(CFF).dColor = DrawColor : DrawBoxAndText(0)
                  End If
               End If

            Case %IDM_DrawColor
               FieldType = %TypeDraw
               iResult = DrawColor
               DrawColor = SelectColor(DrawColor)
               If iResult <> DrawColor And CFF > -1 Then
                  If FF(CFF).FieldType = %TypeText Then
                     FF(CFF).dColor = DrawColor
                     DrawBoxAndText(0)
                  End If
               End If

            Case %IDM_KillGBA : KillGBA

            Case %IDM_ShowLibrary     : ShowLibrary Xor=1     : ManageLibrary : SetMenusAndToolbar : ResizeWindow
            Case %IDM_ShowCFFBoundary : ShowCFFBoundary Xor=1 : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_ShowBoundary    : ShowBoundary Xor=1    : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_AutoSave        : AutoSave Xor= 1       : SetMenusAndToolbar
            Case %IDM_AutoTAB         : AutoTAB Xor= 1        : SetMenusAndToolbar
            Case %IDM_AutoOpenPDF     : AutoOpenPDF Xor= 1    : SetMenusAndToolbar
            Case %IDM_AutoUnDraw      : AutoUnDraw Xor= 1     : SetMenusAndToolbar

            Case %IDM_EditAtTop : EditAtTop Xor= 1 : SetMenusAndToolbar : ResizeWindow

            Case %IDM_OpenPDF : ShellExecute(hDlg, "Open", Exe.Path$ + "pdf", $Nul, $Nul, %SW_Restore)

            Case %IDM_StampBG
               iResult = StampBG
               StampBG = SelectColor(StampBG)
               If iResult <> StampBG Then UpdateStamps : SelectCFS %Red

            Case %IDM_Home  : Graphic Set View 0,0
            Case %IDM_End   : Graphic Set View 0,9999

            Case %IDM_Return   : If AutoTAB Then GoToNextField
            Case %IDM_Tab      : GoToNextField
            Case %IDM_ShiftTab : GoToPreviousField

            Case %IDM_DrawLine    : FieldType = %TypeDraw : DrawType = %DrawLine    : ReplaceDrawButton : SetMenusAndToolbar
            Case %IDM_DrawArrow   : FieldType = %TypeDraw : DrawType = %DrawArrow   : ReplaceDrawButton : SetMenusAndToolbar
            Case %IDM_DrawBox     : FieldType = %TypeDraw : DrawType = %DrawBox     : ReplaceDrawButton : SetMenusAndToolbar
            Case %IDM_DrawEllipse : FieldType = %TypeDraw : DrawType = %DrawEllipse : ReplaceDrawButton : SetMenusAndToolbar

            Case %IDM_Stamp256 : StampSize = 256 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 256 : UpdateStampsize((256-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp192 : StampSize = 192 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                    i=FF(CFF).ssize
                    FF(CFF).ssize = 192 : UpdateStampsize((192-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp128 : StampSize = 128 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 128 : UpdateStampsize((128-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp96  : StampSize = 96 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 96 : UpdateStampsize((96-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp64  : StampSize = 64 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 64 : UpdateStampsize((64-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp48  : StampSize = 48 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 48 : UpdateStampsize((48-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp32  : StampSize = 32 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 32 : UpdateStampsize((32-i)\2) : DrawBoxAndText(0)
                  End If
               End If
            Case %IDM_Stamp24  : StampSize = 24 : FieldType = %TypeStamp : SetMenusAndToolbar
               If CFF > -1 Then
                  If FF(CFF).FieldType = %TypeStamp Then
                     i=FF(CFF).ssize
                     FF(CFF).ssize = 24 : UpdateStampsize((24-i)\2) : DrawBoxAndText(0)
                  End If
               End If

            Case %IDM_StampHorz  : StampHorz Xor= 1 : SetMenusAndToolbar : If CFF>-1 Then FF(CFF).shorz = StampHorz : DrawBoxAndText(0)
            Case %IDM_StampVert  : StampVert Xor= 1 : SetMenusAndToolbar : If CFF>-1 Then FF(CFF).svert = StampVert : DrawBoxAndText(0)

            Case %IDM_Stamp192 : UpdateStampsize IIf(StampSize>192,-1,1)*(192-Stampsize)\2 : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp128 : UpdateStampsize IIf(StampSize>128,-1,1)*(128-Stampsize)\2 : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp96  : UpdateStampsize IIf(StampSize>96,-1,1)*(96-Stampsize)\2   : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp64  : UpdateStampsize IIf(StampSize>64,-1,1)*(64-Stampsize)\2   : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp48  : UpdateStampsize IIf(StampSize>48,-1,1)*(48-Stampsize)\2   : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp32  : UpdateStampsize IIf(StampSize>32,-1,1)*(32-Stampsize)\2   : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)
            Case %IDM_Stamp24  : UpdateStampsize IIf(StampSize>24,-1,1)*(24-Stampsize)\2   : FieldType = %TypeStamp : SetMenusAndToolbar : DrawBoxAndText(0)

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_Test     : ? Str$(CFF)
         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Draw
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hDraw, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Stamp
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hStamp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Font
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           TrackPopupMenu (hFontT, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
            Case %IDT_OpenImage To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                  PTT = Cb.LParam
                  Select Case Cb.NmId
                     Case %IDT_OpenImage     : @PTT.@lpszText = "Open Image File"
                     Case %IDT_Save          : @PTT.@lpszText = "Save Annotated Text"
                     Case %IDT_PDF           : @PTT.@lpszText = "Save Annotated Image as PDF"
                     Case %IDT_Clear         : @PTT.@lpszText = "Remove All Fields"
                     Case %IDT_Undo          : @PTT.@lpszText = "Remove Move Recent"

                     Case %IDT_Plus          : @PTT.@lpszText = "Increase Field Size"
                     Case %IDT_Minus         : @PTT.@lpszText = "Decrease Field Size"

                     Case %IDT_Copy          : @PTT.@lpszText = "Copy Annotated Image to Clipboard"
                     Case %IDT_Paste         : @PTT.@lpszText = "Use Clipboard As Image"
                     Case %IDT_Font          : @PTT.@lpszText = "Select Font for Fields"
                     Case %IDT_Settings      : @PTT.@lpszText = "Display Summary Report"
                     Case %IDT_Help          : @PTT.@lpszText = "Open Online Help Page"
                  End Select
               End Select
         End Select
   End Select
End Function

Sub LoadFormFile
   ReDim FF(%MaxFields)
   If IsFile(ImageFileName + ".gba") Then
      Open ImageFileName + ".gba" For Binary As #1
      Get #1,, FF()
      Close #1
   Else
      CFF = -1
   End If
End Sub

Sub LoadImageFile
   'load JPG/GIF/PNG image to memory bitmap from file
   Local pImage,pGraphics,hDC As Dword
   Local token As Dword, StartupInput As GdiplusStartupInput

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load image/get properties
   GdipLoadImageFromFile((ImageFileName), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,imgW)                 'get width
   GdipGetImageHeight(pImage,imgH)                'get height

   'display image in Graphic control
'   If hBMP Then
'      Graphic Attach hBMP,0
'      Graphic Bitmap End
'   End IF
   Graphic Bitmap New imgW,imgH To hBMP
   Graphic Attach hBMP,0
   Graphic Get DC To hDC                             'hDC is for memory bitmap
   GdipCreateFromHDC(hDC, pGraphics)                 'create graphic object
   GdipDrawImage(pGraphics, pImage, 0,0)             'draw image at 0,0

   'cleanup
   If pImage Then GdipDisposeImage(pImage)           'GDIP cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)   'GDIP cleanup

   'shut downn GDIPlus
   GdiplusShutdown token      ' Shutdown GDI+
End Sub

Function SelectImage() As String
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   If OkToProceed("newimage") = 0 Then Exit Function
   title$ = "Open Image"
   filter$ = "Images" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
   startfolder$ = ImageFileName
   startfile$ = ImageFileName
   defaultext$ = ""
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   If Len(filevar$) Then
      Dirty = 0
      ImageFileName = LCase$(filevar$)
      LoadImageFile
      LoadFormFile
Control Kill hDlg, %IDC_Graphic
CreateGraphic
'      Graphic Attach hDlg, %IDC_Graphic, ReDraw
      Graphic Set Virtual imgW, imgH   'large virtual canvas
'      Graphic Clear
'      Graphic ReDraw
      Graphic Copy hBMP,0
      ResizeWindow
      DrawBoxAndText(0)
      UpdateStatusBar
   End If
End Function

Sub Settings_INI(Task$)
   Local x,y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "940", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "570", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ImageFileName", Exe.Path$ + "images\star_trek.jpg", ImageFileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Marker", "X", Marker, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SymbolCategory", "marker", SymbolCategory, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName: FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "1", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "FontColor", "0", temp, %Max_Path, INIFileName:  FontColor = Val(temp)
      Getprivateprofilestring "All", "TrueImageSize", "0", temp, %Max_Path, INIFileName:  TrueImageSize = Val(temp)
      Getprivateprofilestring "All", "CFF", "-1", temp, %Max_Path, INIFileName:  CFF = Val(temp)
      Getprivateprofilestring "All", "CFS", "0", temp, %Max_Path, INIFileName:  CFS = Val(temp)
      Getprivateprofilestring "All", "CFD", "0", temp, %Max_Path, INIFileName:  CFD = Val(temp)
      Getprivateprofilestring "All", "DrawType", Str$(%DrawBox), temp, %Max_Path, INIFileName:  DrawType = Val(temp)
      Getprivateprofilestring "All", "DrawColor", "0", temp, %Max_Path, INIFileName:  DrawColor = Val(temp)
      Getprivateprofilestring "All", "DrawWidth", "2", temp, %Max_Path, INIFileName:  DrawWidth = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName:  AutoSave = Val(temp)
      Getprivateprofilestring "All", "AutoOpenPDF", "1", temp, %Max_Path, INIFileName:  AutoOpenPDF = Val(temp)
      Getprivateprofilestring "All", "AutoUnDraw", "1", temp, %Max_Path, INIFileName:  AutoUnDraw = Val(temp)
      Getprivateprofilestring "All", "AutoTAB", "0", temp, %Max_Path, INIFileName:  AutoTAB = Val(temp)
      Getprivateprofilestring "All", "EditAtTop", "0", temp, %Max_Path, INIFileName:  EditAtTop = Val(temp)
      Getprivateprofilestring "All", "FieldType", Str$(%TypeText), temp, %Max_Path, INIFileName:  FieldType = Val(temp)
      Getprivateprofilestring "All", "StampBG", Str$(%rgb_Gainsboro), temp, %Max_Path, INIFileName:  StampBG = Val(temp)
      Getprivateprofilestring "All", "StampSize", "64", temp, %Max_Path, INIFileName:  StampSize = Val(temp)
      Getprivateprofilestring "All", "ShowBoundary", "0", temp, %Max_Path, INIFileName:  ShowBoundary = Val(temp)
      Getprivateprofilestring "All", "ShowLibrary", "1", temp, %Max_Path, INIFileName:  ShowLibrary = Val(temp)
      Getprivateprofilestring "All", "ShowCFFBoundary", "1", temp, %Max_Path, INIFileName:  ShowCFFBoundary = Val(temp)
      Getprivateprofilestring "All", "Filled", "1", temp, %Max_Path, INIFileName:  Filled = Val(temp)
      Getprivateprofilestring "All", "SymbolSelect", "0", temp, %Max_Path, INIFileName:  SymbolSelect = Val(temp)
      Getprivateprofilestring "All", "StampHorz", "0", temp, %Max_Path, INIFileName:  StampHorz = Val(temp)
      Getprivateprofilestring "All", "StampVert", "0", temp, %Max_Path, INIFileName:  StampVert = Val(temp)

      'custom colors
      For x = 0 To 15
         Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(temp)
      Next x
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "ImageFileName",ImageFileName, INIFileName
      WritePrivateProfileString "All", "Marker",Marker, INIFileName
      WritePrivateProfileString "All", "SymbolCategory",SymbolCategory, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "FontColor", Str$(FontColor), INIFileName
      WritePrivateProfileString "All", "TrueImageSize", Str$(TrueImageSize), INIFileName
      WritePrivateProfileString "All", "CFF", Str$(CFF), INIFileName
      WritePrivateProfileString "All", "CFS", Str$(CFS), INIFileName
      WritePrivateProfileString "All", "CFD", Str$(CFD), INIFileName
      WritePrivateProfileString "All", "DrawType", Str$(DrawType), INIFileName
      WritePrivateProfileString "All", "DrawColor", Str$(DrawColor), INIFileName
      WritePrivateProfileString "All", "DrawWidth", Str$(DrawWidth), INIFileName
      WritePrivateProfileString "All", "AutoSave", Str$(AutoSave), INIFileName
      WritePrivateProfileString "All", "AutoOpenPDF", Str$(AutoOpenPDF), INIFileName
      WritePrivateProfileString "All", "AutoUnDraw", Str$(AutoUnDraw), INIFileName
      WritePrivateProfileString "All", "AutoTAB", Str$(AutoTAB), INIFileName
      WritePrivateProfileString "All", "EditAtTop", Str$(EditAtTop), INIFileName
      WritePrivateProfileString "All", "FieldType", Str$(FieldType), INIFileName
      WritePrivateProfileString "All", "StampBG", Str$(StampBG), INIFileName
      WritePrivateProfileString "All", "StampSize", Str$(StampSize), INIFileName
      WritePrivateProfileString "All", "ShowBoundary", Str$(ShowBoundary), INIFileName
      WritePrivateProfileString "All", "ShowLibrary", Str$(ShowLibrary), INIFileName
      WritePrivateProfileString "All", "ShowCFFBoundary", Str$(ShowCFFBoundary), INIFileName
      WritePrivateProfileString "All", "Filled", Str$(Filled), INIFileName
      WritePrivateProfileString "All", "SymbolSelect", Str$(SymbolSelect), INIFileName
      WritePrivateProfileString "All", "StampHorz", Str$(StampHorz), INIFileName
      WritePrivateProfileString "All", "StampVert", Str$(StampVert), INIFileName

      'custom colors
      For x = 0 To 15
         temp = Str$(CustomColorList.c(x))
         WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
      Next x
   End If
End Sub

Sub LoadComboBox
   Local i As Long
End Sub

Sub CreateStamps
   Local i,iCount As Long, temp$, oldtemp$
   ReDim AllSymbols(1000)
   'create the graphic control to hold the stamp images
   Control Add Graphic, hDlg, %IDC_Stamps,"", 5,95,70,500, %WS_Visible Or %WS_Border Or %SS_Notify
   Graphic Attach hDlg, %IDC_Stamps, ReDraw
   Graphic Set Virtual 40,5000
   Graphic Color %Black, StampBG
   Graphic Clear

  'add the stamps image namess to an array
   temp$ = Dir$("stamps\*.*")
   While Len(temp$)
      AllSymbols(iCount) = LCase$(Exe.Path$ + "stamps\" + temp$)
      Incr iCount
      temp$ = Dir$
   Wend
   ReDim Preserve AllSymbols(iCount-1)
   Array Sort AllSymbols()

   'Fill combobox
   Control Add ComboBox, hDlg, %IDC_ComBobox, ,5,65,70,150, %WS_TabStop Or %CBS_AutoHScroll Or %WS_VScroll Or %CBS_DropDownList, %WS_Ex_ClientEdge
   ComboBox Add hDlg, %IDC_ComboBox, "all"
   oldtemp$ = ""
   For i = 0 To UBound(AllSymbols)
      temp$ = Parse$(PathName$(Name,AllSymbols(i)),"_", 1)
      If temp$ <> oldtemp$ Then ComboBox Add hDlg, %IDC_ComboBox, temp$ : oldtemp$ = temp$
   Next i
   ComboBox Get Count hDlg,%IDC_ComboBox To iCount
   For i = 1 To iCount
      ComboBox Get Text hDlg, %IDC_ComboBox, i To temp$
      If temp$ = SymbolCategory Then ComboBox Select hDlg, %IDC_ComboBox, i : Exit For
   Next i
End Sub

Sub UpdateStamps
   Local i,iCount As Long

   ReDim Symbols(1000)
   Graphic Attach hDlg, %IDC_Stamps, ReDraw
   Graphic Color %Black, StampBG
   Graphic Clear
   'create the Symbols list from the AllSymbols array
   For i = 0 To UBound(AllSymbols)
      If SymbolCategory = "all" Then
         Symbols(iCount) = AllSymbols(i)
         Incr iCount
      ElseIf  (SymbolCategory = Parse$(PathName$(Name,AllSymbols(i)),"_", 1)) Then
         Symbols(iCount) = AllSymbols(i)
         Incr iCount
      End If
   Next i

   ReDim Preserve Symbols(iCount-1)
   Graphic Set Virtual 70,4000
   'put the symbols on the graphic control
   For i = 0 To UBound(Symbols)
      DrawStamp(Symbols(i),i)
   Next i
   Graphic ReDraw
End Sub

Sub CreateGraphic
   Control Add Graphic, hDlg, %IDC_Graphic,"", 70,65,10,10, %WS_Visible Or %WS_Border Or %SS_Notify
   Control Handle hDlg, %IDC_Graphic To hGraphic
   OldGraphicProc = SetWindowLong(hGraphic, %GWL_WndProc, CodePtr(NewGraphicProc))  'subclass
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Font New FontName, FontSize, FontAttr To hFont
   Graphic Set Font hFont
   Graphic Color %Black, %rgb_LightGray
   Graphic Clear
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,32,25 To hImageList
    ImageList Add Icon hImageList, "logo"         '1
    ImageList Add Icon hImageList, "xsettings"    '2
    ImageList Add Icon hImageList, "xhelp"        '3
    ImageList Add Icon hImageList, "xopen"        '4
    ImageList Add Icon hImageList, "xsaveas"      '5
    ImageList Add Icon hImageList, "xxprint"      '6
    ImageList Add Icon hImageList, "xfont"        '7
    ImageList Add Icon hImageList, "xclear"       '8
    ImageList Add Icon hImageList, "xcopy"        '9
    ImageList Add Icon hImageList, "xsort"        '10
    ImageList Add Icon hImageList, "xpdf"         '11
    ImageList Add Icon hImageList, "xundo"        '12
    ImageList Add Icon hImageList, "xpaste"       '13
    ImageList Add Icon hImageList, "xtext"        '14
    ImageList Add Icon hImageList, "xdraw"        '15
    ImageList Add Icon hImageList, "xstamp"       '16
    ImageList Add Icon hImageList, "xcut"         '17
    ImageList Add Icon hImageList, "xplus"        '18
    ImageList Add Icon hImageList, "xminus"       '19

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_OpenImage, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Save, %BTNS_Button, "Save"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_PDF, %BTNS_Button, "PDF"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Clear, %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_Undo, %BTNS_Button, "Undo"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18, %IDT_Plus, %BTNS_Button, "Incr"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 19, %IDT_Minus, %BTNS_Button, "Decr"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Copy, %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13, %IDT_Paste, %BTNS_Button, "Paste"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14, %IDT_Text, %BTNS_CheckGroup, "Text"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16, %IDT_Stamp, %BTNS_CheckGroup Or %BTNS_DropDown, "Stamp"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 15, %IDT_Draw, %BTNS_CheckGroup Or %BTNS_DropDown, Choose$(DrawType,"Line","Arrow","Box","Ellipse") At 16

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Font, %BTNS_Button Or %BTNS_DropDown, "Font"
'    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Print, %BTNS_Button, "Print"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button, "Help"

   'Draw button context menu
   Menu New PopUp To hDraw
   Menu Add String, hDraw, "Line", %IDM_DrawLine, %MF_Enabled
   Menu Add String, hDraw, "Arrow", %IDM_DrawArrow, %MF_Enabled
   Menu Add String, hDraw, "Box", %IDM_DrawBox, %MF_Enabled
   Menu Add String, hDraw, "Ellipse", %IDM_DrawEllipse, %MF_Enabled
   Menu Add String, hDraw, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hDraw, "Width=1", %IDM_Width1, %MF_Enabled
   Menu Add String, hDraw, "Width=2", %IDM_Width2, %MF_Enabled
   Menu Add String, hDraw, "Width=4", %IDM_Width4, %MF_Enabled
   Menu Add String, hDraw, "Width=8", %IDM_Width8, %MF_Enabled
   Menu Add String, hDraw, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hDraw, "Select Draw Color", %IDM_DrawColor, %MF_Enabled
   Menu Add String, hDraw, "White", %IDM_DrawWhite, %MF_Enabled
   Menu Add String, hDraw, "Black", %IDM_DrawBlack, %MF_Enabled
   Menu Add String, hDraw, "Red", %IDM_DrawRed, %MF_Enabled
   Menu Add String, hDraw, "Blue", %IDM_DrawBlue, %MF_Enabled
   Menu Add String, hDraw, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hDraw, "Filled Shapes", %IDM_Filled, %MF_Enabled

   'Settings button context menu
   Menu New PopUp To hSettings
   Menu Add String, hSettings, "Select Stamp Library BG Color", %IDM_StampBG, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "Print Annotated Page", %IDM_Print, %MF_Enabled
   Menu Add String, hSettings, "Open PDF Folder", %IDM_OpenPDF, %MF_Enabled
   Menu Add String, hSettings, "Sort Text Fields", %IDM_Sort, %MF_Enabled
   Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hSettings, "AutoSave Annotation Fields", %IDM_AutoSave, %MF_Enabled
   Menu Add String, hSettings, "AutoOpen PDF Folder", %IDM_AutoOpenPDF, %MF_Enabled
   Menu Add String, hSettings, "AutoTAB on ENTER", %IDM_AutoTAB, %MF_Enabled
   Menu Add String, hSettings, "Auto Deselect Draw After Drawing", %IDM_AutoUnDraw, %MF_Enabled
   Menu Add String, hSettings, "Show Current Field Boundary", %IDM_ShowCFFBoundary, %MF_Enabled
   Menu Add String, hSettings, "Show All Field Boundaries", %IDM_ShowBoundary, %MF_Enabled
   Menu Add String, hSettings, "Edit Position At Top", %IDM_EditAtTop, %MF_Enabled
   Menu Add String, hSettings, "Show Stamp Library", %IDM_ShowLibrary, %MF_Enabled

   'Font button context menu
   Menu New PopUp To hFontT
   Menu Add String, hFontT, "All Same Font", %IDM_AllSameFont, %MF_Enabled
   Menu Add String, hFontT, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hFontT, "Select Text Color", %IDM_FontColor, %MF_Enabled
   Menu Add String, hFontT, "White", %IDM_FontWhite, %MF_Enabled
   Menu Add String, hFontT, "Black", %IDM_FontBlack, %MF_Enabled
   Menu Add String, hFontT, "Red", %IDM_FontRed, %MF_Enabled
   Menu Add String, hFontT, "Blue", %IDM_FontBlue, %MF_Enabled
   Menu Add String, hFontT, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hFontT, "Size = 8", %IDM_Font8, %MF_Enabled
   Menu Add String, hFontT, "Size = 10", %IDM_Font10, %MF_Enabled
   Menu Add String, hFontT, "Size = 12", %IDM_Font12, %MF_Enabled
   Menu Add String, hFontT, "Size = 16", %IDM_Font16, %MF_Enabled
   Menu Add String, hFontT, "Size = 24", %IDM_Font24, %MF_Enabled
   Menu Add String, hFontT, "Size = 32", %IDM_Font32, %MF_Enabled
   Menu Add String, hFontT, "Size = 54", %IDM_Font54, %MF_Enabled
   Menu Add String, hFontT, "Size = 72", %IDM_Font72, %MF_Enabled

   'Draw button context menu
   Menu New PopUp To hStamp
   Menu Add String, hStamp, "256x256", %IDM_Stamp256, %MF_Enabled
   Menu Add String, hStamp, "192x192", %IDM_Stamp192, %MF_Enabled
   Menu Add String, hStamp, "128x128", %IDM_Stamp128, %MF_Enabled
   Menu Add String, hStamp, "96x96", %IDM_Stamp96, %MF_Enabled
   Menu Add String, hStamp, "64x64", %IDM_Stamp64, %MF_Enabled
   Menu Add String, hStamp, "48x48", %IDM_Stamp48, %MF_Enabled
   Menu Add String, hStamp, "32x32", %IDM_Stamp32, %MF_Enabled
   Menu Add String, hStamp, "24x24", %IDM_Stamp24, %MF_Enabled
   Menu Add String, hStamp, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hStamp, "Horizontal Flip", %IDM_StampHorz, %MF_Enabled
   Menu Add String, hStamp, "Vertical Flip", %IDM_StampVert, %MF_Enabled

     'Graphic context menu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Remove Selected Field", %IDM_RemoveCFF, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Send Selected Field to Back", %IDM_SendToBack, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Show Data for Selected Field", %IDM_ShowCFFData, %MF_Enabled

   'TextBox context menu
   Menu New PopUp To hContextTB
   Menu Add String, hContextTB, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextTB , "Cut",   %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextTB, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextTB, "Delete", %IDM_Delete,  %MF_Enabled
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Text, IIf(FieldType = %TypeText,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Stamp, IIf(FieldType = %TypeStamp,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Draw, IIf(FieldType = %TypeDraw,1,0) * %TBState_Checked Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_AutoSave,  IIf(AutoSave,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoOpenPDF,  IIf(AutoOpenPDF,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoUnDraw,  IIf(AutoUnDraw,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoTAB,  IIf(AutoTAB,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_EditAtTop,  IIf(EditAtTop,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ShowBoundary,  IIf(ShowBoundary,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ShowLibrary,  IIf(ShowLibrary,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ShowCFFBoundary,  IIf(ShowCFFBoundary,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hDraw, ByCmd %IDM_DrawLine,   IIf(DrawType=%DrawLine,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_DrawArrow,  IIf(DrawType=%DrawArrow,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_DrawBox,    IIf(DrawType=%DrawBox,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_DrawEllipse,IIf(DrawType=%DrawEllipse,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hDraw, ByCmd %IDM_Filled,IIf(Filled,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hDraw, ByCmd %IDM_Width1,IIf(DrawWidth=1,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_Width2,IIf(DrawWidth=2,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_Width4,IIf(DrawWidth=4,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hDraw, ByCmd %IDM_Width8,IIf(DrawWidth=8,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hStamp, ByCmd %IDM_Stamp256,  IIf(StampSize=256,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp192,  IIf(StampSize=192,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp128,  IIf(StampSize=128,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp96,  IIf(StampSize=96,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp64,  IIf(StampSize=64,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp48,  IIf(StampSize=48,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp32,  IIf(StampSize=32,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_Stamp24,  IIf(StampSize=24,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hStamp, ByCmd %IDM_StampHorz,  IIf(StampHorz,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hStamp, ByCmd %IDM_StampVert,  IIf(StampVert,%MFS_Checked,0) Or %MFS_Enabled

    Menu Set State hFontT, ByCmd %IDM_Font8,   IIf(FontSize=8,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font10,  IIf(FontSize=10,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font12,  IIf(FontSize=12,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font16,  IIf(FontSize=16,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font24,  IIf(FontSize=24,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font32,  IIf(FontSize=32,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font54,  IIf(FontSize=54,%MFS_Checked,0) Or %MFS_Enabled
    Menu Set State hFontT, ByCmd %IDM_Font72,  IIf(FontSize=72,%MFS_Checked,0) Or %MFS_Enabled
End Sub

Sub PrintFileName
   On Error GoTo EndPrint
   Local Zoom As Single
   XPrint Attach Choose
   DrawBoxAndText(1)
   Zoom = XPrint(Ppi.X) / Graphic(Ppi.X)
   XPrint Set StretchMode %HalfTone
   XPrint Stretch hGraphic, 0, (0,0)-(imgW-1,imgH-1) To (0,0)-( Zoom*(imgW-1), Zoom*(imgH-1))
   XPrint Close
   DrawBoxAndText(0)
EndPrint:
End Sub

Function SelectMainFont() As Long
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "  " + FontName + "  " + Str$(FontSize) + "  " + IIf$(FontAttr,"Bold","Normal")
      Function = 1
   End If
End Function

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
   End If
End Function

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub SaveFormData
   Dirty = 0
   Open ImageFileName + ".gba" For Binary As #1
   Put #1,, FF()
   SetEof #1
   Close #1
End Sub

Sub DrawBoxAndText(BlackFlag As Long)
   Local i,tempColor As Long, rc As Rect
   Graphic Set Overlap %True
   'image
   Graphic Copy hBMP,0
   'display form data on image
   For i = 0 To UBound(FF)
      If FF(i).used = 0 Then Iterate For
      If BlackFlag Then tempColor = %Black Else tempColor = FF(i).fcolor
      Font New FF(i).fName, FF(i).fSize, FF(i).fAttr To hFont
      Graphic Set Font hFont
      Select Case FF(i).FieldType
         Case %TypeText
            Graphic Set Pos (FF(i).rc.nLeft, FF(i).rc.nTop+4)
            If i = CFF And FF(i).s = "" Then
               Graphic Color %Red, -2
               Graphic Print Marker
            ElseIf i = CFF Then
               Graphic Color IIf(BlackFlag,tempColor,%Red), -2
               GraphicDisplayText(i)
            Else
               Graphic Color tempColor, -2
               GraphicDisplayText(i)
            End If
         Case %TypeDraw
            Graphic Width FF(i).dwidth
            Select Case FF(i).dtype
               Case %DrawLine
                  Graphic Line (FF(i).rc.nLeft, FF(i).rc.nTop)-(FF(i).rc.nRight,FF(i).rc.nBottom),FF(i).dcolor
               Case %DrawBox
                  Graphic Box (FF(i).rc.nLeft, FF(i).rc.nTop)-(FF(i).rc.nRight,FF(i).rc.nBottom),0,FF(i).dcolor, IIf(FF(i).dfilled,FF(i).dColor,-2)
               Case %DrawEllipse
                  Graphic Ellipse (FF(i).rc.nLeft, FF(i).rc.nTop)-(FF(i).rc.nRight,FF(i).rc.nBottom),FF(i).dcolor, IIf(FF(i).dfilled,FF(i).dColor,-2)
               Case %DrawArrow
                  DrawArrowAngle(i)
            End Select
         Case %TypeStamp
            DrawSymbol i
      End Select
      If ShowBoundary Or (ShowCFFBoundary And i=CFF) Then Graphic Box (FF(i).rc.nLeft, FF(i).rc.nTop)-(FF(i).rc.nRight,FF(i).rc.nBottom),0,%Green
   Next i
   Graphic ReDraw
End Sub

Function FFName As String
   Local temp$, fName$
   fName$ = ImageFileName
   temp$ = Right$(fName$,4)
   Replace temp$ With "_ff" + temp$ In fName$
   Function = fName$
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(17)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E     : ac(c).cmd   = %IDT_PDF          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F     : ac(c).cmd   = %IDT_Font         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H     : ac(c).cmd   = %IDM_RemoveEmpty  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_K     : ac(c).cmd   = %IDM_KillGBA      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L     : ac(c).cmd   = %IDM_ShowLibrary  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O     : ac(c).cmd   = %IDT_OpenImage    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P     : ac(c).cmd   = %IDM_Print        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R     : ac(c).cmd   = %IDM_ShowBoundary : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S     : ac(c).cmd   = %IDT_Save         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T     : ac(c).cmd   = %IDM_Test         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U     : ac(c).cmd   = %IDM_UnSelectAll  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z     : ac(c).cmd   = %IDT_Undo         : Incr c

   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Return  : ac(c).cmd   = %IDM_Return     : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Home  : ac(c).cmd   = %IDM_Home         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_End   : ac(c).cmd   = %IDM_End          : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_TAB   : ac(c).cmd   = %IDM_TAB          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FSHIFT   : ac(c).key   = %VK_TAB   : ac(c).cmd   = %IDM_ShiftTAB     : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1    : ac(c).cmd   = %IDT_Help         : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub ShowCFFData
   Local temp$
   If CFF = -1 Then Exit Sub
   temp$ += $CrLf + "Field Information:" + $CrLf
   Select Case FF(CFF).fieldtype
      Case %TypeText
         temp$ += Format$(CFF+1,"000") + " Text " + _
                  Str$(FF(CFF).rc.nLeft) + Str$(FF(CFF).rc.nTop) + Str$(FF(CFF).rc.nRight) + Str$(FF(CFF).rc.nBottom) + _
                  FF(CFF).s + $CrLf
      Case %TypeStamp
         temp$ += Format$(CFF+1,"000") + " Stamp " + _
                  Str$(FF(CFF).rc.nLeft) + Str$(FF(CFF).rc.nTop) + Str$(FF(CFF).rc.nRight) + Str$(FF(CFF).rc.nBottom) + _
                  PathName$(Namex,FF(CFF).s) + $CrLf
      Case %TypeDraw
         temp$ += Format$(CFF+1,"000") + " Draw " + _
                  "Shape:" + FF(CFF).s + "  Width:" + Str$(FF(CFF).dWidth) + _
                  Str$(FF(CFF).rc.nLeft) + Str$(FF(CFF).rc.nTop) + Str$(FF(CFF).rc.nRight) + Str$(FF(CFF).rc.nBottom) + $CrLf
   End Select
   MsgBox temp$, %MB_Ok + %MB_IconInformation + %MB_TaskModal, "Annotation Summary"
End Sub

Sub DisplayReport
   Local temp$, i,sCount,tCount,dCount As Long

   For i = 0 To UBound(FF)
      If FF(i).used = 0 Then Iterate For
      Select Case FF(i).fieldtype
         Case %TypeText  : Incr tCount
         Case %TypeStamp : Incr sCount
         Case %TypeDraw  : Incr dCount
      End Select
   Next i

   temp$  = "gbAnnotate   v" + $ver + $CrLf
   temp$ += ImageFileName + $CrLf
   temp$ += "Image Size: " + Str$(imgW) + "x" + Trim$(Str$(imgH)) + $CrLf
   temp$ += "Font: " + FontName + "  " + Str$(FontSize) + "  " + IIf$(FontAttr,"Bold","Normal") + $CrLf
   temp$ += "Drawing: " + Choose$(DrawType,"Line","Arrow","Box","Ellipse") + "   Width:" + Str$(DrawWidth) + $CrLf
   If sCount+tCount+dCount = 0 Then
      temp$ += "Fields:  0" + $CrLf
   Else
      temp$ += "Fields: " + Str$(sCount+tCount) +  "  Text Fields: " + Str$(tCount) + "   Stamps: " + Str$(sCount) +  "   Draw: " + Str$(dCount) + $CrLf
   End If
  temp$ += "Current Field:  " + IIf$(CFF=-1,"None selected",Trim$(Str$(CFF+1))) + $CrLf

   If sCount+tCount+dCount Then
      temp$ += $CrLf + "Field Information:" + $CrLf
      For i = 0 To %MaxFields
         If FF(i).used = 0 Then Iterate For
         Select Case FF(i).fieldtype
            Case %TypeText
               temp$ += Format$(i+1,"000") + " Text " + _
                        Str$(FF(i).rc.nLeft) + Str$(FF(i).rc.nTop) + Str$(FF(i).rc.nRight) + Str$(FF(i).rc.nBottom) + _
                        "   " + FF(i).s + $CrLf
            Case %TypeStamp
               temp$ += Format$(i+1,"000") + " Stamp " + _
                        Str$(FF(i).rc.nLeft) + Str$(FF(i).rc.nTop) + Str$(FF(i).rc.nRight) + Str$(FF(i).rc.nBottom) + _
                        "   " + PathName$(Namex,FF(i).s) + $CrLf
            Case %TypeDraw
               temp$ += Format$(i+1,"000") + " Draw " + _
                        "Shape:" + FF(i).s + "  Width:" + Str$(FF(i).dWidth) + _
                        Str$(FF(i).rc.nLeft) + Str$(FF(i).rc.nTop) + Str$(FF(i).rc.nRight) + Str$(FF(i).rc.nBottom) + $CrLf
         End Select
      Next i
   End If
   MsgBox temp$, %MB_Ok + %MB_IconInformation + %MB_TaskModal, "Annotation Summary"
End Sub

Sub LoadFFName
End Sub

Sub CopyForm
   Clipboard Reset
   Clipboard Set Bitmap hGraphic
End Sub

Sub UpdateStatusbar
   Local temp$, i,tCount,sCount,dCount As Long
   'if empty
   If CFF = -1 Then
      temp$ = "No fields!"
   Else
      For i = 0 To UBound(FF)
         If FF(i).used = 0 Then Iterate For
         Select Case FF(i).fieldtype
            Case %TypeText  : Incr tCount
            Case %TypeStamp : Incr sCount
            Case %TypeDraw  : Incr dCount
         End Select
         temp$ = "Fields:    Text:" + Str$(tCount) + "   Stamps:" + Str$(sCount) + "   Draw:" + Str$(dCount) + "  " + FF(CFF).s
      Next i
   End If
   Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, temp$
End Sub

Sub ClearAll
   CFF = -1
   Dirty = 1
   ReDim FF(%MaxFields)
   UpdateStatusBar
   DrawBoxAndText(0)
   Control Set Text hDlg, %IDC_TextBox, ""
End Sub

Sub GoToNextField
   Local i As Long
   For i = CFF+1 To %MaxFields
      If FF(i).used Then
         CFF = i
         Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         UpdateStatusBar
         DrawBoxAndText(0)
         IfTextFieldSetFocus
         Exit Sub
      End If
   Next i
   For i = 0 To CFF-1
      If FF(i).used Then
         CFF = i
         Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         UpdateStatusBar
         DrawBoxAndText(0)
         IfTextFieldSetFocus
         Exit Sub
      End If
   Next i
End Sub

Sub IfTextFieldSetFocus
   If CFF > -1 Then
      If FF(CFF).fieldtype = %TypeText Then
         Control Send hDlg, %IDC_TextBox, %EM_SetSel, 0, -1
         Control Set Focus hDlg, %IDC_TextBox
      End If
   End If
End Sub

Sub GoToPreviousField
   Local i As Long
   For i = CFF-1 To 0 Step -1
      If FF(i).used Then
         CFF = i
         Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         UpdateStatusBar
         DrawBoxAndText(0)
         IFTextFieldSetFocus
         Exit Sub
      End If
   Next i
   For i = %MaxFields To CFF+1 Step -1
      If FF(i).used Then
         CFF = i
         Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         UpdateStatusBar
         DrawBoxAndText(0)
         IFTextFieldSetFocus
         Exit Sub
      End If
   Next i
End Sub

Sub SetCFF(pt As Point)
   Local i As Long, rc As Rect
   'CFF becomes the first unused element of FF
   For i = 0 To %MaxFields
      If FF(i).used = 1 Then Iterate For
      FF(i).used = 1
      FF(i).fieldtype = FieldType
      CFF = i
      Select Case FieldType
         Case %TypeText
            FF(i).fname  = FontName
            FF(i).fsize  = FontSize
            FF(i).fattr  = FontAttr
            FF(i).fcolor = FontColor
            FF(i).s = "X"
            FF(i).rc.nLeft   = pt.x
            FF(i).rc.nBottom = pt.y
            Font New FF(i).fName, FF(i).fSize, FF(i).fAttr To hFont
            Graphic Set Font hFont
            FF(i).rc.nRight  = pt.x + Graphic(Text.Size.X,"X")
            FF(i).rc.nTop    = pt.y - Graphic(Text.Size.Y,"X")
         Case %TypeDraw
            FF(i).s = Choose$(DrawType,"Line","Arrow","Box","Ellipse")
            FF(i).rc.nLeft   = pt.x
            FF(i).rc.nTop    = pt.y
            FF(i).rc.nRight  = pt.x
            FF(i).rc.nBottom = pt.y
            FF(i).fname   = FontName
            FF(i).fsize   = FontSize
            FF(i).fattr   = FontAttr
            FF(i).fcolor  = FontColor
            FF(i).dtype   = DrawType
            FF(i).dcolor  = DrawColor
            FF(i).dwidth  = DrawWidth
            FF(i).dfilled = Filled
         Case %TypeStamp
            FF(i).s = Symbols(CFS)
            FF(i).ssize = StampSize
            FF(i).svert = StampVert
            FF(i).shorz = StampHorz
            FF(i).rc.nLeft    = pt.x - StampSize\2
            FF(i).rc.nTop     = pt.y - StampSize\2
            FF(i).rc.nRight   = FF(i).rc.nLeft + StampSize
            FF(i).rc.nBottom  = FF(i).rc.nTop + StampSize
      End Select
      Exit Sub
   Next i
End Sub

Sub SortFields
   Dirty = 1
   Array Sort FF(), Call FieldSort
   CFF = 0
   Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
   UpdateStatusBar
   DrawBoxAndText(0)
   IFTextFieldSetFocus
End Sub

Function FieldSort(A As FormFields, B As FormFields) As Long
   Local RowHeight As Long
   RowHeight = 30
   If A.used < B.used Then Function = +1 : Exit Function
   If A.used > B.used Then Function = -1 : Exit Function
   If A.rc.nBottom\RowHeight < B.rc.nBottom\RowHeight Then Function = -1 : Exit Function
   If A.rc.nBottom\RowHeight > B.rc.nBottom\RowHeight Then Function = +1 : Exit Function
   If A.rc.nLeft > B.rc.nLeft Then Function = +1 : Exit Function
   If A.rc.nLeft < B.rc.nLeft Then Function = -1 : Exit Function
End Function

Sub ExportToPDF
   Local iReturn As Long, fName$
   ChDir Exe.Path$ + "pdf"
   If IsFile (fName$) Then Kill fName$
   fName$ = Exe.Path$ + "pdf\gbannotate.pdf"
   Sleep 1000
   iReturn = Shell ( "cmd /c jpeg2pdf.exe *.jpg -o gbannotate.pdf" , 0 )
End Sub

Sub RemoveCFF
   Local i,Flag As Long
   If CFF = -1 Then Exit Sub

   Array Delete FF(CFF)

   'go backwards in the TAB order
   For i = CFF-1 To 0 Step -1
      If FF(i).used Then Flag = 1 : CFF = i : Exit For
   Next i


   'go forward
   If Flag = 0 Then
      For i = CFF To %MaxFields
         If FF(i).used Then Flag = 1 : CFF = i : Exit For
      Next i
   End If

   If Flag = 0 Then CFF = -1

   If CFF = -1 Then
      Control Set Text hDlg, %IDC_TextBox, ""
      UpdateStatusBar
      DrawBoxAndText(0)
      Exit Sub
   Else
      Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
      UpdateStatusBar
      DrawBoxAndText(0)
      IFTextFieldSetFocus
   End If
End Sub

Function FieldUnderCursor() As Long
   Local i As Long, rc As Rect, pt As Point
   'does the point already exist
   pt = ContextPT
   ScreenToClient hGraphic, pt
   For i = 0 To %MaxFields
      If FF(i).used = 0 Then Iterate For
      rc = FF(i).rc
      OrderPoints(rc)
      If PtInRect(rc,pt) Then
         Function = i
         Exit Function
      End If
   Next i
   Function = -1
End Function

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Sub Undo
   Local i As Long
   'delete the recent Field
   For i = %MaxFields To 0 Step -1
      If FF(i).used = 0 Then Iterate For
      Array Delete FF(i)
      Dirty = 1
      Exit For
   Next i

   'select the first available field
   CFF = -1
   For i = %MaxFields To 0 Step -1
      If FF(i).used = 0 Then Iterate For
      CFF = i
      Exit For
   Next i

   If CFF > -1 Then Control Set Text hDlg, %IDC_TextBox, FF(CFF).s

   UpdateStatusBar
   DrawBoxAndText(0)
   IfTextFieldSetFocus
End Sub

Sub SaveAsJPG
   'initialize GDIPlus
   Local s As String, sEncoderClsid As Guid, pImage, hBitmap, pGraphics As Dword
   Local sMimeType As String, fName As WStringZ * %Max_Path, hGraphicDC As Dword
   Local token As Dword, StartupInput As GdiplusStartupInput
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   sMimeType = "image/jpeg"
   fName = Exe.Path$ + "pdf\gbannotate.jpg"

   s = GDIPlusGetEncoderClsid((sMimeType))
   sEncoderClsid = Guid$(s)

   Graphic Get DC To hGraphicDC
   hBitmap = GetCurrentObject(hGraphicDC, %OBJ_Bitmap)              'from graphic target
   GDIpCreateBitmapFromHBITMAP( hBitmap, ByVal %Null, pImage)       'create GDI+ image (pImage)
   GdipCreateFromHDC hGraphicDC, pGraphics                          'create graphic object containing Graphic Control
   GdipDrawImageRect pGraphics, pImage, 0, 0, 140, 110              'use (0,0)-(140,110)
   GdipSaveImageToFile pImage,(fName), sEncoderClsid, ByVal %Null   'save to file

   'cleanup
   If pImage Then GdipDisposeImage(pImage)
   If pGraphics Then GdipDeleteGraphics(pGraphics)

   'shut downn GDIPlus
   GdiplusShutdown token      ' Shutdown GDI+
End Sub

Sub PasteFromClipboard
   Local hClipBoard As Dword
   'get clipboard image
   Clipboard Get Bitmap To hClipboard
   If hClipBoard = 0 Then Beep : Exit Sub
   If OkToProceed("paste") = 0 Then Exit Sub
   Graphic Attach hClipboard, 0
   Graphic Save Exe.Path$ + $ClipBoardBMP
   'open clipboard image
   Dirty = 0
   ImageFileName = Exe.Path$ + $ClipBoardBMP
   LoadImageFile
   LoadFormFile

Control Kill hDlg, %IDC_Graphic
CreateGraphic

'   Graphic Attach hDlg, %IDC_Graphic, ReDraw
'   Graphic Clear
   Graphic Set Virtual imgW, imgH   'large virtual canvas
   Graphic Copy hBMP,0
   ResizeWindow
   DrawBoxAndText(0)
   UpdateStatusBar
End Sub

Sub MoveRC(DDX As Long, DDY As Long)
   OffsetRect FF(CFF).rc, ddx, ddy
   DrawBoxAndText(0)
End Sub

Sub DrawStamp(fName$, iPos As Long)
   'load JPG/GIF/PNG image to memory bitmap from file
   Local pImage,pGraphics,hDCStamp As Dword
   Local token As Dword, StartupInput As GdiplusStartupInput
   Local imgWS, imgHS, x,y As Long

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load image/get properties
   GdipLoadImageFromFile((fName$), pImage)  'pImage - image object
   GdipGetImageWidth(pImage,imgWS)                 'get width
   GdipGetImageHeight(pImage,imgHS)                'get height

   'display image in Graphic control
   Graphic Attach hDlg, %IDC_Stamps
   Graphic Get DC To hDCStamp                    'hDC is for memory bitmap
   GdipCreateFromHDC(hDCStamp, pGraphics)        'create graphic object
   x = 10
   y = iPos*40+4

   GdipDrawImageRectI(pGraphics, pImage, x,y,32,32) 'draw image at next available positiong in IDC_Stamps

   'cleanup
   If pImage Then GdipDisposeImage(pImage)           'GDIP cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)   'GDIP cleanup

   'shut downn GDIPlus
   GdiplusShutdown token      ' Shutdown GDI+
End Sub

Sub SelectCFS(sColor As Long)
   Graphic Attach hDlg, %IDC_Stamps, ReDraw
   Graphic Width 2
   Graphic Box (5,CFS*40+1)-(49,CFS*40+40), 20, sColor
   Graphic ReDraw
End Sub

Sub HighlightNewCS
   Local i As Long, pt As Point
   SelectCFS StampBG   'unselect old selection
   GetCursorPos pt
   ScreenToClient GetDlgItem(hDlg,%IDC_Stamps), pt
   pt.y += Graphic(View.Y)
   i = UBound(Symbols)*40
   If pt.y > i Then pt.y = i
   CFS = pt.y \ 40
   SelectCFS %Red      'select new selection
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Sub

Sub DrawSymbol(iPos As Long)
   'load JPG/GIF/PNG image to memory bitmap from file
   Local pImage,pGraphics,hDC As Dword
   Local token As Dword, StartupInput As GdiplusStartupInput
   Local imgWS, imgHS As Long

   'initialize GDIPlus
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(token, StartupInput, ByVal %NULL)

   'load image/get properties
   GdipLoadImageFromFile((FF(iPos).s), pImage)     'pImage - image object
   GdipGetImageWidth(pImage,imgWS)                 'get width
   GdipGetImageHeight(pImage,imgHS)                'get height

   'display image in Graphic control
   Graphic Get DC To hDC                    'hDC is for memory bitmap
   GdipCreateFromHDC(hDC, pGraphics)        'create graphic object
   If FF(iPos).shorz Then GdipImageRotateFlip pImage, %RotateNoneFlipX
   If FF(iPos).svert Then GdipImageRotateFlip pImage, %RotateNoneFlipY
   GdipDrawImageRectI(pGraphics, pImage, FF(iPos).rc.nLeft, FF(iPos).rc.nTop,FF(iPos).ssize,FF(iPos).ssize) 'draw image at next available positiong in IDC_Stamps

   'cleanup
   If pImage Then GdipDisposeImage(pImage)           'GDIP cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)   'GDIP cleanup

   'shut downn GDIPlus
   GdiplusShutdown token      ' Shutdown GDI+
End Sub

Function NewTextBoxProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldTextBoxProc, hWnd, Msg, wParam, lParam)
End Function

Sub KillGBA
   If MsgBox("Kill " + ImageFileName + ".gba" + " ?", %MB_OkCancel + %MB_IconQuestion + %MB_TaskModal, "Kill GBA File") = %IdOk Then
      If IsFile( ImageFileName + ".gba" ) Then Kill  ImageFileName + ".gba"
      ClearAll
   End If
End Sub

Sub IncreaseFieldSize
   Dirty = 1
   If CFF = -1 Then Exit Sub
   Select Case FF(CFF).fieldType
      Case %TypeText
         Select Case FF(CFF).fsize
            Case  <=8 : FF(CFF).fsize = 10
            Case <=10 : FF(CFF).fsize = 12
            Case <=12 : FF(CFF).fsize = 16
            Case <=16 : FF(CFF).fsize = 24
            Case <=24 : FF(CFF).fsize = 32
            Case <=32 : FF(CFF).fsize = 54
            Case <=54 : FF(CFF).fsize = 72
         End Select
         RefreshCFF
      Case %TypeStamp
         Select Case FF(CFF).ssize
            Case 24  : FF(CFF).ssize = 32  : UpdateStampSize(4)
            Case 32  : FF(CFF).ssize = 48  : UpdateStampSize(8)
            Case 48  : FF(CFF).ssize = 64  : UpdateStampSize(8)
            Case 64  : FF(CFF).ssize = 96  : UpdateStampSize(16)
            Case 96  : FF(CFF).ssize = 128 : UpdateStampSize(16)
            Case 128 : FF(CFF).ssize = 192 : UpdateStampSize(32)
            Case 192 : FF(CFF).ssize = 256 : UpdateStampSize(32)
         End Select
         DrawBoxAndText(0)
      Case %TypeDraw
         UpdateDrawSize(1)
         DrawBoxAndText(0)
   End Select
End Sub

Sub DecreaseFieldSize
   Dirty = 1
   If CFF = -1 Then Exit Sub
   Select Case FF(CFF).fieldType
      Case %TypeText
         Select Case FF(CFF).fsize
            Case >=72 : FF(CFF).fsize = 54
            Case >=54 : FF(CFF).fsize = 32
            Case >=32 : FF(CFF).fsize = 24
            Case >=24 : FF(CFF).fsize = 16
            Case >=16 : FF(CFF).fsize = 12
            Case >=12 : FF(CFF).fsize = 10
            Case >=10 : FF(CFF).fSize = 8
         End Select
         RefreshCFF
      Case %TypeStamp
         Select Case FF(CFF).ssize
            Case 32  : FF(CFF).ssize = 24 : UpdateStampSize(-4)
            Case 48  : FF(CFF).ssize = 32 : UpdateStampSize(-8)
            Case 64  : FF(CFF).ssize = 48 : UpdateStampSize(-8)
            Case 96  : FF(CFF).ssize = 64 : UpdateStampSize(-16)
            Case 128 : FF(CFF).ssize = 96 : UpdateStampSize(-16)
            Case 192 : FF(CFF).ssize = 128 : UpdateStampSize(-32)
            Case 256 : FF(CFF).ssize = 192 : UpdateStampSize(-32)
         End Select
         DrawBoxAndText(0)
      Case %TypeDraw
         UpdateDrawSize(-1)
         DrawBoxAndText(0)
   End Select
End Sub

Sub UpdateDrawSize(Flag As Long)
   Local ddx,ddy,a,c,b,d As Long
   ddx = Flag * 0.1 * Abs(FF(CFF).rc.nRight-FF(CFF).rc.nLeft)
   ddy = Flag * 0.1 * Abs(FF(CFF).rc.nBottom-FF(CFF).rc.nTop)

   If Flag = -1 Then
      If Abs(ddx) < 2 Or Abs(ddy) < 2 Then Exit Sub
   End If

   a = FF(CFF).rc.nLeft   :  b = FF(CFF).rc.nTop
   c = FF(CFF).rc.nRight  :  d = FF(CFF).rc.nBottom

   If a < c And b < d Then
      'Q4
      FF(CFF).rc.nLeft   -= ddx
      FF(CFF).rc.nTop    -= ddy
      FF(CFF).rc.nRight  += ddx
      FF(CFF).rc.nBottom += ddy

   ElseIf a > c And b < d Then
      'Q3
      FF(CFF).rc.nLeft   += ddx
      FF(CFF).rc.nTop    -= ddy
      FF(CFF).rc.nRight  -= ddx
      FF(CFF).rc.nBottom += ddy

   ElseIf a > c And b > d Then
      'Q2
      FF(CFF).rc.nLeft   += ddx
      FF(CFF).rc.nTop    += ddy
      FF(CFF).rc.nRight  -= ddx
      FF(CFF).rc.nBottom -= ddy

   ElseIf a < c And b > d Then
      'Q1
      FF(CFF).rc.nLeft   -= ddx
      FF(CFF).rc.nTop    += ddy
      FF(CFF).rc.nRight  += ddx
      FF(CFF).rc.nBottom -= ddy
   End If
End Sub

Sub UpdateStampSize(ddx As Long)
   If CFF = -1 Then Exit Sub
   FF(CFF).rc.nLeft   = FF(CFF).rc.nLeft - ddx
   FF(CFF).rc.nTop    = FF(CFF).rc.nTop  - ddx
   FF(CFF).rc.nRight  = FF(CFF).rc.nLeft + FF(CFF).ssize
   FF(CFF).rc.nBottom = FF(CFF).rc.nTop  + FF(CFF).ssize
End Sub

Sub DrawArrowAngle(i As Long)
   Local a,b,c,d,e,f,dist As Single, Arrow As ArrowType, unit,rx,ry As Single, rc As Rect

   rc = FF(i).rc
   OrderPoints rc
'   If IsRectEmpty(rc) Then Exit Sub

   'just to make typing easier in the equations
   a = FF(i).rc.nLeft   :  b = FF(i).rc.nTop
   c = FF(i).rc.nRight  :  d = FF(i).rc.nBottom
   e = a + (c-a) * 2/3 :  f = b + (d-b) * 2/3
   rx = a-c   : ry = b-d
   dist = Sqr(rx*rx + ry*ry)
   rx /= dist : ry /= dist
   unit = 1/12 * dist
   arrow.count = 7
   arrow.x1 = a+unit*ry   : arrow.y1 = b-unit*rx
   arrow.x2 = e+unit*ry   : arrow.y2 = f-unit*rx
   arrow.x3 = e+2*unit*ry : arrow.y3 = f-2*unit*rx
   arrow.x4 = c           : arrow.y4 = d
   arrow.x5 = e-2*unit*ry : arrow.y5 = f+2*unit*rx
   arrow.x6 = e-unit*ry   : arrow.y6 = f+unit*rx
   arrow.x7 = a-unit*ry   : arrow.y7 = b+unit*rx
   Graphic Polygon Arrow, FF(i).dColor, IIf(FF(i).dfilled,FF(i).dColor,-2)

'? Str$(arrow.x1) +Str$(arrow.y1) + $CrLf + _
'  Str$(arrow.x2) +Str$(arrow.y2) + $CrLf + _
'  Str$(arrow.x3) +Str$(arrow.y3) + $CrLf + _
'  Str$(arrow.x4) +Str$(arrow.y4) + $CrLf + _
'  Str$(arrow.x5) +Str$(arrow.y5) + $CrLf + _
'  Str$(arrow.x6) +Str$(arrow.y6) + $CrLf + _
'  Str$(arrow.x7) +Str$(arrow.y7)

End Sub

Function OkToProceed(task$) As Long
   Local Style&, temp$,tempB$
   If Dirty = 0 Then Function = 1 : Exit Function
   Style& = %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal
   Select Case task$
      Case "drop"     : temp$ = "Save changes before opening dropped file?" : tempB$ = "Drop File"
      Case "end"      : temp$ = "Save changes before closing gbAnnotate?"   : tempB$ = "Close gbAnnotate"
      Case "newimage" : temp$ = "Save changes before opening new image?"   : tempB$ = "Open Image"
      Case "paste"    : temp$ = "Save changes before pasting new image?"   : tempB$ = "Paste Image"
   End Select
   Select Case MsgBox(temp$, Style&, tempB$)
      Case %IdYes
         SaveFormData
         Function = 1    'False - go ahead with closing the application
      Case %IdNo
         Function = 1    'False - go ahead with closing the application
      Case %IdCancel
         Function = 0   'True - abort the close - no further processing needed
   End Select
End Function

Sub ResizeWindow
   Local w,h,vw,vh As Long
   Dialog Get Client hDlg To w,h

'   Control Set Size hDlg, %IDC_Graphic, w-80,h-80

   If ShowLibrary Then
      Control Set Size hDlg, %IDC_Stamps, 70,h-125
      Control Set Size hDlg, %IDC_Textbox, w-85, 20
      Control Set Size hDlg, %IDC_Graphic, Min(w-85,ImgW),Min(h-120,ImgH)

      If EditAtTop Then
         'textbox is at top
         Control Set Loc hDlg, %IDC_TextBox, 80, 65
         Control Set Loc hDlg, %IDC_Graphic, 80, 90
      Else
         'textbox is at bottom
         Control Set Loc hDlg, %IDC_TextBox, 80, h-50
         Control Set Loc hDlg, %IDC_Graphic, 80, 65
      End If
   Else
      Control Set Size hDlg, %IDC_Textbox, w-10, 20
      Control Set Size hDlg, %IDC_Graphic, Min(w-10,ImgW),Min(h-120,ImgH)

      If EditAtTop Then
         'textbox is at top
         Control Set Loc hDlg, %IDC_TextBox, 5, 65
         Control Set Loc hDlg, %IDC_Graphic, 5, 90
      Else
         'textbox is at bottom
         Control Set Loc hDlg, %IDC_TextBox, 5, h-50
         Control Set Loc hDlg, %IDC_Graphic, 5, 65
      End If
   End If

   Control ReDraw hDlg, %IDC_Graphic
End Sub

Sub OrderPoints(R As Rect)
   Local tempR As Rect
   tempR.nLeft = Min&(R.nLeft,R.nRight)
   tempR.nRight = Max&(R.nLeft,R.nRight)
   tempR.nTop = Min&(R.nTop,R.nBottom)
   tempR.nBottom = Max&(R.nTop,R.nBottom)
   R = tempR
End Sub

Sub AllSameFont
   Local i As Long
   For i = 0 To %MaxFields
      If FF(i).fieldtype <> %TypeText Then Iterate For
      FF(i).fname = FontName
      FF(i).fsize = FontSize
      FF(i).fattr = FontAttr
      FF(i).fcolor = FontColor
   Next i
   DrawBoxAndText(0)
End Sub

Sub SendToBack
   Local i As Long, tempT As FormFields
   i = FieldUnderCursor
   If i = -1 Then Exit Sub
   tempT = FF(i)
   Array Delete FF(i)
   Array Insert FF(0)
   FF(UBound(FF)) = tempT
   DrawBoxAndText(0)
End Sub

Sub RemoveEmptyFields
   Local i As Long
   For i = 0 To %MaxFields
      If IsRectEmpty(FF(i).rc) Then FF(i).used = 0
   Next i
End Sub

Sub GraphicDisplayText(i As Long)
   Local j,iCount,y As Long
   y = FF(i).rc.nTop+4
   iCount = ParseCount(FF(i).s,$ML)
   For j = 1 To iCount
      Graphic Print Parse$(FF(i).s,$ML,j)
      y += Graphic(Text.Size.Y,FF(i).s)
      Graphic Set Pos (FF(i).rc.nLeft, y)
   Next j
End Sub

Function NewGraphicProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local pt As Point,rc As Rect, i,iResult As Long
   Static ddx,ddy As Long
   Select Case Msg
       Case %WM_LButtonUp
          FieldMoveInWork = 0 : FieldDrawinWork = 0
          ReleaseCapture
          If CFF>-1 And FF(CFF).fieldType = %TypeText Then
             SetFocus hTextBox
             SendMessage hTextbox, %EM_SetSel, 0, -1
          ElseIf CFF>-1 And FF(CFF).fieldType = %TypeDraw Then
             FieldType = %TypeText
             SetMenusAndToolbar
          End If

       Case %WM_LButtonDown
          SetCapture hWnd
          GetCursorPos pt
          ScreenToClient hGraphic, pt
          pt.x += Graphic(View.X)
          pt.y += Graphic(View.Y)
          Select Case FieldType
             Case %TypeDraw
                FieldDrawInWork = 1
                SetCFF(pt)  'sets next available FF()
             Case %TypeText, %TypeStamp
                'get the field under the cursor
                iResult = -1
                For i = %MaxFields To 0 Step -1
                   If FF(i).used = 0 Then Iterate For
                   rc = FF(i).rc
                   OrderPoints(rc)
                   If PtInRect(rc,pt) Then
                      iResult = i
                      Exit For
                   End If
                Next i
                'move the rect of the field under the cursor
                If iResult > -1 Then
                   FieldMoveInWork = 1
                   CFF = iResult
                   ddx = FF(CFF).rc.nLeft - pt.x
                   ddy = FF(CFF).rc.nTop -  pt.y
                Else
                   CFF = -1
                   DrawBoxAndText(0)
                End If
          End Select
          If CFF > -1 Then Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
          DrawBoxAndText(0)
       Case %WM_MouseMove
          If FieldMoveInWork Then
             Dirty = 1
             GetCursorPos pt
             ScreenToClient hGraphic, pt
             pt.x += Graphic(View.X)
             pt.y += Graphic(View.Y)
             MoveRC pt.x + ddx - FF(CFF).rc.nLeft , pt.y + ddy - FF(CFF).rc.nTop
             DrawBoxAndText(0)
          ElseIf FieldDrawInWork Then
             Dirty = 1
             GetCursorPos pt
             ScreenToClient hGraphic, pt
             pt.x += Graphic(View.X)
             pt.y += Graphic(View.Y)
             FF(CFF).rc.nRight = pt.x
             FF(CFF).rc.nBottom = pt.y
             DrawBoxAndText(0)
          End If
      Case %WM_LButtonDblClk
         If FieldType = %TypeDraw Then Exit Function
         Dirty = 1
         GetCursorPos pt
         ScreenToClient GetDlgItem(hDlg,%IDC_Graphic), pt
         pt.x += Graphic(View.X)
         pt.y += Graphic(View.Y)
         SetCFF(pt)  'sets CFF to the FF() that exists at the cursor or to the next available FF()
         Control Set Text hDlg, %IDC_TextBox, FF(CFF).s
         UpdateStatusBar
         DrawBoxAndText(0)
         IfTextFieldSetFocus
      Case %WM_KeyDown
         Select Case wParam
            Case %VK_Delete : RemoveCFF
            Case %VK_Left   : MoveRC(-1,0) : DrawBoxAndText(0) : Exit Function
            Case %VK_Right  : MoveRC(+1,0) : DrawBoxAndText(0) : Exit Function
            Case %VK_Up     : MoveRC(0,-1) : DrawBoxAndText(0) : Exit Function
            Case %VK_Down   : MoveRC(0,+1) : DrawBoxAndText(0) : Exit Function
        End Select
   End Select
   Function = CallWindowProc(OldGraphicProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "pdf") = %False Then MkDir Exe.Path$ + "pdf"
   If IsFolder (Exe.Path$ + "stamps") = %False Then MkDir Exe.Path$ + "stamps"
   If IsFolder (Exe.Path$ + "temp") = %False Then MkDir Exe.Path$ + "temp"
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "icons") = %False Then MkDir Exe.Path$ + "icons"
End Sub

Sub ReplaceDrawButton
   Toolbar Delete Button hDlg, %IDC_Toolbar, ByCmd %IDT_Draw
   Toolbar Add Button    hDlg, %IDC_Toolbar, 15, %IDT_Draw, %BTNS_CheckGroup Or %BTNS_DropDown, Choose$(DrawType,"Line","Arrow","Box","Ellipse") At 16
End Sub

Function CFFPoints() As String
   Local w,h As Long
   w = FF(CFF).rc.nRight - FF(CFF).rc.nLeft
   h = FF(CFF).rc.nBottom - FF(CFF).rc.nTop
   Function = Str$(FF(CFF).rc.nLeft) + Str$(FF(CFF).rc.nTop) + Str$(FF(CFF).rc.nRight) + Str$(FF(CFF).rc.nBottom) + $CrLf + Str$(w) + " x " + Str$(h)
End Function

Sub RefreshCFF
   Dirty = 1
   Font New FF(CFF).fName, FF(CFF).fSize, FF(CFF).fAttr To hFont
   Graphic Set Font hFont
   SetCFFBoundary
   DrawBoxAndText(0)
End Sub

Sub SetCFFBoundary   'GraphicSetMultilineBoundary
   Local i,iCount As Long
   Font New FF(CFF).fName, FF(CFF).fSize, FF(CFF).fAttr To hFont
   Graphic Set Font hFont
   iCount = ParseCount(FF(CFF).s,$ML)
   FF(CFF).rc.nBottom = FF(CFF).rc.nTop + iCount * Graphic(Text.Size.Y,FF(CFF).s)
   FF(CFF).rc.nRight  = 0
   For i = 1 To iCount
      FF(CFF).rc.nRight = Max(FF(CFF).rc.nRight, FF(CFF).rc.nLeft + Graphic(Text.Size.X,Parse$(FF(CFF).s,$ML,i)))
   Next i
End Sub

Sub ManageLibrary
   Control Show State hDlg, %IDC_ComboBox, IIf(ShowLibrary, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_Stamps, IIf(ShowLibrary, %SW_Show, %SW_Hide)
End Sub
